import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_kztek_library/flutter_kztek_library.dart';

class AccountInfoPage extends StatefulWidget {
  @override
  _AccountInfoPageState createState() => _AccountInfoPageState();
}

class _AccountInfoPageState extends State<AccountInfoPage> {
  List<SelectListModel> dataLanguage() {
    var data = List<SelectListModel>();

    data.add(SelectListModel(itemValue: "1", itemText: "C#"));
    data.add(SelectListModel(itemValue: "2", itemText: "Java"));

    return data;
  }

  List<SelectListModel> dataFoot() {
    var data = List<SelectListModel>();

    data.add(SelectListModel(itemValue: "1", itemText: "Vanilla"));
    data.add(SelectListModel(itemValue: "2", itemText: "Chocolate"));

    return data;
  }

  @override
  Widget build(BuildContext context) {
    BoxDecoration boxDecorations(
        {double radius = 8,
          Color color = Colors.transparent,
          Color bgColor = Colors.white,
          var showShadow = false}) {
      return BoxDecoration(
          color: bgColor,
          //gradient: LinearGradient(colors: [bgColor, whiteColor]),
          boxShadow: showShadow
              ? [BoxShadow(color: Color(0x95E9EBF0), blurRadius: 10, spreadRadius: 2)]
              : [BoxShadow(color: Colors.transparent)],
          border: Border.all(color: color),
          borderRadius: BorderRadius.all(Radius.circular(radius)));
    }

    return SafeArea(
      child: Scaffold(
        backgroundColor: Colors.teal,
        appBar: AppBar(
          title: Text('Sửa thông tin'),
        ),
        body: SingleChildScrollView(
            child: Column(
              children: [
                Container(
                  decoration: boxDecorations(showShadow: true),
                  padding: EdgeInsets.all(16.0),
                  margin: EdgeInsets.all(16.0),
                  child: Column(
                    children: [
                      FormWidget(
                        autoValidate: true,
                        initialValue: {},
                        bodyForm: <Widget>[
                          DatePicker(
                            readOnly: false,
                            enabled: true,
                            attribute: 'datepicker',
                            format: DateFormatType.dMY,
                            isRequired: true,
                            initialValue: DateTime.now(),
                            decoration: InputDecoration(
                                labelText: 'Chọn ngày', icon: Icon(Icons.calendar_today)),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: value),
                          ),
                          TimePicker(
                            readOnly: false,
                            enabled: true,
                            attribute: 'timepicker',
                            isRequired: true,
                            initialValue: DateTime.now(),
                            decoration: InputDecoration(
                                labelText: 'Chọn giờ', icon: Icon(Icons.access_time)),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: value),
                          ),
                          DateTimePicker(
                            readOnly: false,
                            enabled: true,
                            attribute: 'datetimepicker',
                            format: DateFormatType.dMYHms,
                            isRequired: true,
                            initialValue: DateTime.now(),
                            decoration: InputDecoration(
                                labelText: 'Chọn ngày giờ', icon: Icon(Icons.av_timer)),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: value),
                          ),
                          NumericField(
                            readOnly: false,
                            enabled: true,
                            attribute: 'age',
                            minValue: 0,
                            maxValue: 100,
                            isRequired: true,
                            initialValue: '0',
                            decoration: InputDecoration(labelText: 'Nhập tuổi'),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          EmailField(
                            readOnly: false,
                            enabled: true,
                            attribute: 'email',
                            isRequired: true,
                            initialValue: 'abc@gmail.com',
                            decoration: InputDecoration(
                                labelText: 'Nhập email', icon: Icon(Icons.email)),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          InputField(
                            readOnly: false,
                            enabled: true,
                            attribute: 'text',
                            isRequired: true,
                            initialValue: '',
                            decoration: InputDecoration(
                                labelText: 'Nhập text', icon: Icon(Icons.lock)),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          PasswordField(
                            readOnly: false,
                            enabled: true,
                            attribute: 'password',
                            isRequired: true,
                            initialValue: '',
                            decoration: InputDecoration(
                                labelText: 'Nhập password', icon: Icon(Icons.lock)),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          DropdownField(
                            readOnly: false,
                            attribute: 'gender',
                            isRequired: true,
                            hint: 'Select gender',
                            decoration: InputDecoration(labelText: 'Chọn giới tính'),
                            data: ['Male', 'Female', 'Other']
                                .map((gender) =>
                                DropdownMenuItem(value: gender, child: Text("$gender")))
                                .toList(),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          CheckboxSelect(
                            readOnly: false,
                            attribute: 'languages',
                            decoration: InputDecoration(labelText: 'Chọn ngôn ngữ'),
                            data: dataLanguage(),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          FilterChipSelect(
                            readOnly: false,
                            attribute: 'xlanguages',
                            data: dataLanguage(),
                            decoration: InputDecoration(labelText: 'Chọn ngôn ngữ'),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          RadioSelect(
                            readOnly: false,
                            attribute: 'food1',
                            data: dataFoot(),
                            decoration: InputDecoration(labelText: 'Chọn kem'),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          ChoiceChipSelect(
                            readOnly: false,
                            attribute: 'food',
                            data: dataFoot(),
                            decoration: InputDecoration(labelText: 'Chọn kem'),
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          SwitchField(
                            attribute: 'accept',
                            initialValue: false,
                            readOnly: false,
                            labelText: 'Đồng ý?',
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          ),
                          RateField(
                            readOnly: false,
                            initialValue: 1,
                            attribute: 'rate',
                            labelText: 'Like',
                            maxValue: 5,
                            iconSize: 32.0,
                            onChange: (value) => Helper.toastHelper.showToastInfo(
                                context: context,
                                gravity: toastGravity.center,
                                message: '$value'),
                          )
                        ],
                      )
                    ],
                  ),
                )
              ],
            )
        ),
      ),
    );
  }
}
