import 'package:dio/dio.dart';
import 'package:flutter_kztek_library/src/statics/Statics.dart';

class DioHelper {
  Dio _getConfig({AuthType type, String token}) {
    // Dio dio = new Dio();

    // if (token != "") {
    //   dio.options.headers['Authorization'] =
    //       Statics.authType(type: type, token: token);
    // }

    // or new Dio with a BaseOptions instance.
    BaseOptions options = new BaseOptions(
        //connectTimeout: 5000,
        receiveTimeout: 3000,
        sendTimeout: 3000,
        headers: {"Authorization": Statics.authType(type: type, token: token)});

    Dio dio = new Dio(options);

    return dio;
  }

  Future<Response> httpGet(
      {String url,
      AuthType type,
      String token = "",
      Map<String, dynamic> queryParameters}) async {
    var response = await _getConfig(type: type, token: token)
        .get(url, queryParameters: queryParameters);

    return response;
  }

  Future<Response> httpPostJ(
      {String url,
      AuthType type,
      String token = "",
      Map<String, dynamic> data}) async {
    var response =
        await _getConfig(type: type, token: token).post(url, data: data);

    return response;
  }

  Future<Response> httpPostF(
      {String url, AuthType type, String token = "", FormData data}) async {
    var response =
        await _getConfig(type: type, token: token).post(url, data: data);

    return response;
  }

  Future<Response> httpPutJ(
      {String url,
      AuthType type,
      String token = "",
      Map<String, dynamic> queryParameters,
      Map<String, dynamic> data}) async {
    var response = await _getConfig(type: type, token: token)
        .put(url, queryParameters: queryParameters, data: data);

    return response;
  }

  Future<Response> httpPutF(
      {String url,
      AuthType type,
      String token = "",
      Map<String, dynamic> queryParameters,
      FormData data}) async {
    var response = await _getConfig(type: type, token: token)
        .put(url, queryParameters: queryParameters, data: data);

    return response;
  }

  Future<Response> httpDelete(
      {String url,
      AuthType type,
      String token = "",
      Map<String, dynamic> queryParameters}) async {
    var response = await _getConfig(type: type, token: token)
        .delete(url, queryParameters: queryParameters);

    return response;
  }
}
